<template>
  <nav
    class="dark:bg-black-500 fixed top-0 z-40 w-full py-3 bg-white"
    :class="{ 'shadow border-transparent': scrolled }"
    @click="scrollToTop"
  >
    <div class="md:container sm:px-8 lg:px-16 flex justify-between px-4 mx-auto">
      <div class="flex items-center justify-between w-full h-16">
        <div class="lg:w-1/5 flex items-center pr-4" @click.stop="noop">
          <NuxtLink
            :to="localePath('/')"
            class="flex-1 flex-shrink-0 text-xl font-bold"
            :aria-label="`${settings.title} Logo`"
          >
            <div class="flex items-center">
              <IconLogoLight v-if="$colorMode.value === 'light'" />
              <IconLogoDark v-else />
              <span
                class="font-logo text-black-500 dark:text-white mb-1 ml-2 text-2xl font-medium leading-none tracking-tight"
                >{{ settings.title }}</span
              >
            </div>
          </NuxtLink>
        </div>
        <div v-if="!menu" class="lg:block hidden w-64 mr-16">
          <AppSearch />
        </div>
        <div v-if="!menu" class="md:flex items-center justify-end flex-1 hidden">
          <div
            v-for="(navItem, index) in navItems"
            :key="index"
            class="dropdown relative inline-block mr-6 cursor-pointer"
          >
            <div class="flex items-center">
              <p
                class="dark:text-gray-300 hover:text-primary-300 dark-hover:text-primary-500"
                id="menu-button"
                aria-expanded="true"
                aria-haspopup="true"
              >
                {{ navItem.name }}
              </p>
              <icon-chevron-down class="w-5 h-5" />
            </div>
            <drop-down :links="navItem.links" />
          </div>

          <div class="flex items-center mr-6">
            <a
              target="_blank"
              href="https://grey.software/credits"
              class="dark:text-gray-300 hover:text-primary-300 dark-hover:text-primary-500"
            >
              Credits
            </a>
          </div>
          <nav-cta class="mr-6" link="https://grey.software/support" text="Support Us" />
          <div class="max-w-maxs flex items-center">
            <AppLangSwitcher />
            <AppColorSwitcher />
          </div>
        </div>
      </div>
      <button
        class="lg:hidden dark:text-gray-300 focus:outline-none ml-6 text-gray-700 rounded-md"
        aria-label="Menu"
        @click.stop="menu = !menu"
      >
        <IconX v-if="menu" class="w-5 h-5" />
        <IconMenu v-else class="w-5 h-5" />
      </button>
    </div>
  </nav>
</template>

<script>
import { mapGetters } from 'vuex'
import CtaButton from '../global/CtaButton.vue'
import IconChevronRight from '../global/IconChevronRight.vue'

export default {
  components: { IconChevronRight, CtaButton },
  data() {
    return {
      navItems: [
        {
          name: 'About',
          links: [
            {
              name: 'Pitch',
              link: 'https://grey.software/pitch',
            },
            {
              name: 'FAQ',
              link: 'https://grey.software/faq',
            },
            {
              name: 'Feedback',
              link: 'https://grey.software/feedback',
            },
            {
              name: 'Analytics',
              link: 'https://grey.software/analytics',
            },
            {
              name: 'Philosophy',
              link: 'https://grey.software/philosophy',
            },
          ],
        },
        {
          name: 'Explore',
          links: [
            {
              name: 'Resources',
              link: 'https://resources.grey.software/',
            },
            {
              name: 'Onboarding',
              link: 'https://onboarding.grey.software/',
            },
            {
              name: 'Organization',
              link: 'https://org.grey.software/',
            },
            {
              name: 'Learn',
              link: 'https://learn.grey.software/',
            },
            {
              name: 'Glossary',
              link: 'https://glossary.grey.software/',
            },
          ],
        },
        {
          name: 'Socials',
          links: [
            {
              name: 'Twitter',
              link: 'https://twitter.com/grey_software',
            },
            {
              name: 'GitHub',
              link: 'https://github.com/grey-software',
            },
            {
              name: 'GitLab',
              link: 'https://gitlab.com/grey-software',
            },
            {
              name: 'Discord',
              link: 'http://community.grey.software',
            },
            {
              name: 'LinkedIn',
              link: 'https://www.linkedin.com/company/grey-software/',
            },
          ],
        },
      ],
      scrolled: 0,
      isOpen: false,
    }
  },
  computed: {
    ...mapGetters(['settings', 'githubUrls', 'lastRelease']),
    menu: {
      get() {
        return this.$store.state.menu.open
      },
      set(val) {
        this.$store.commit('menu/toggle', val)
      },
    },
    logo() {
      if (!this.settings.logo) {
        return
      }

      if (typeof this.settings.logo === 'object') {
        return this.settings.logo
      }

      return {
        light: this.settings.logo,
        dark: this.settings.logo,
      }
    },
  },

  beforeMount() {
    window.addEventListener('scroll', this.handleScroll)
  },
  beforeDestroy() {
    window.removeEventListener('scroll', this.handleScroll)
  },
  methods: {
    handleScroll() {
      this.scrolled = window.scrollY > 0
    },
    scrollToTop() {
      if (window.innerWidth >= 1280) {
        return
      }
      window.scrollTo(0, 0)
    },
    noop() {},
  },
}
</script>
